import { EventEmitter } from '../../stencil.core';
import { ContextMenuLoader } from '../../types/types';
/** @experimental */
export declare class ContextMenu {
    private bodyEl;
    private menuListener;
    private overlay;
    private overlayClickListener;
    private parentEl;
    element: HTMLElement;
    options: any;
    /**
     * Where to attach the overlay when opened
     * Options are `"parent"` or `"target"` which is the default.
     */
    attach: 'parent' | 'target' | HTMLElement;
    /**
     * Loader to get the menu options. The default is to grab whatever is slotted.
     */
    loader: ContextMenuLoader;
    /**
     * Emitted when a selection is made
     */
    anjContextSelect: EventEmitter<string>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    unbindOverlay(): void;
    onElsewhereOpen({ target }: CustomEvent): Promise<void>;
    /**
     * open the date picker
     */
    open(event: MouseEvent): Promise<void>;
    /**
     * close the date picker
     */
    close(): Promise<void>;
    private onClick;
    private bindOverlay;
    private insertOptions;
    private getSlottedOptions;
    render(): any;
}
